Description

The current setup of system tests forces you to have your Selenium/ChromeDriver on your localhost. This is ok if you have a classic

setup with everything on your localhost, but if you are using Docker or you want to configure the tests to run on CI you need to install

ChromeDriver and all the dependencies on the same image with Redmine.

The attached patch adds 4 environment variables that allow you to configure the system tests to run using a remote Selenium URL:

CAPYBARA_SERVER_HOST: to configure the default server to run on a custom IP which can be, for example, your remote

Selenium IP or 0.0.0.0 to listen an all connections

CAPYBARA_SERVER_PORT: to configure the default server port

SELENIUM_REMOTE_URL: remote Selenium IP

CAPYBARA_APP_HOST: by default, the tests expect to have the application running on your localhost. Using this variable, you can

set a custom URL.

With the attached patch, I was able to configure my Gitlab CI setup (#30069) to run the system tests (

https://gitlab.com/redmine-org/redmine/-/jobs/852801841).

Associated revisions

Revision 20428 - 2020-11-19 06:11 - Go MAEDA

Adds CAPYBARA_SERVER_HOST, CAPYBARA_SERVER_PORT, SELENIUM_REMOTE_URL and CAPYBARA_APP_HOST to allow running

system tests on a remote Selenium hub (on CI using Docker images) (#34269).

Patch by Marius BALTEANU.

Revision 20490 - 2020-11-23 01:54 - Go MAEDA

Fix RuboCop Performance/RedundantMerge due to r20428 (#34269).

Revision 20491 - 2020-11-23 01:58 - Go MAEDA

Fix RuboCop Style/MultilineIfModifier due to r20428 (#34269).

Revision 20708 - 2021-01-10 01:10 - Go MAEDA

Adds GOOGLE_CHROME_OPTS_ARGS environment variable to define Google Chrome options arguments (#34269).

Patch by Marius BALTEANU.

History

#1 - 2020-11-17 08:27 - Go MAEDA

The change looks nice.

Would you consider adding description about those four environment variables to source:trunk/doc/RUNNING_TESTS?

#2 - 2020-11-17 08:29 - Marius BĂLTEANU

Go MAEDA wrote:

The change looks nice.

Would you consider adding description about those four environment variables to source:trunk/doc/RUNNING_TESTS?

 Yes, I forgot about docs. Thanks for pointing this out. I will update the patch soon.
#3 - 2020-11-17 20:26 - Marius BĂLTEANU

- File deleted (0001-Adds-CAPYBARA_SERVER_HOST-CAPYBARA_SERVER_PORT-SELEN.patch)

#4 - 2020-11-17 20:26 - Marius BĂLTEANU

- File 0001-Adds-CAPYBARA_SERVER_HOST-CAPYBARA_SERVER_PORT-SELEN.patch added

Here it is the updated version.

#5 - 2020-11-18 00:27 - Go MAEDA

- Target version set to 4.2.0

Setting the target version to 4.2.0.

#6 - 2020-11-19 06:12 - Go MAEDA

- Status changed from New to Closed

- Assignee set to Go MAEDA

Committed the patch (r20428). Thank you for your contribution.

#7 - 2020-11-23 09:34 - Marius BĂLTEANU

Go MAEDA wrote:

Committed the patch (r20428). Thank you for your contribution.

 Thanks Go Maeda for fixing the RuboCop violations.

#8 - 2021-01-09 11:43 - Marius BĂLTEANU

- File 0002-Adds-GOOGLE_CHROME_OPTS_ARGS-environment-variable-to.patch added

One more environment variable that allows to set the Google Chrome Options arguments as a comma-delimited string. Useful to set some required

arguments to run the tests on headless Chrome.

GOOGLE_CHROME_OPTS_ARGS="headless,disable-gpu,no-sandbox,disable-dev-shm-usage" 

#9 - 2021-01-09 11:43 - Marius BĂLTEANU

- Status changed from Closed to Reopened

#10 - 2021-01-10 01:10 - Go MAEDA

- Status changed from Reopened to Closed

Marius BALTEANU wrote:

One more environment variable that allows to set the Google Chrome Options arguments as a comma-delimited string. Useful to set some

required arguments to run the tests on headless Chrome.

[...]

 Committed the patch. Thank you.

Files

0001-Adds-CAPYBARA_SERVER_HOST-CAPYBARA_SERVER_PORT-SELEN.patch3.43 KB 2020-11-17 Marius BĂLTEANU

0002-Adds-GOOGLE_CHROME_OPTS_ARGS-environment-variable-to.patch2.62 KB 2021-01-09 Marius BĂLTEANU
